From MAILER-DAEMON Wed Apr  5 16:45:15 2000
Date: Wed, 5 Apr 2000 16:45:15 +0400 (EET DST)
From: Mail System Internal Data <MAILER-DAEMON@promete.tetm.tubitak.gov.tr>
Subject: DON'T DELETE THIS MESSAGE -- FOLDER INTERNAL DATA
X-IMAP: 0954938715 0000000000
Status: RO

This text is part of the internal format of your mail folder, and is not
a real message.  It is created automatically by the mail system software.
If deleted, important folder data will be lost, and it will be re-created
with the data reset to initial values.

From kdincer@promete.tetm.tubitak.gov.tr Mon Apr  3 16:35:07 2000 +0400
Status: R
X-Status: 
X-Keywords:
Received: from mendelson.ceng.metu.edu.tr (root@mendelson.ceng.metu.edu.tr [144.122.171.110])
	by promete.tetm.tubitak.gov.tr (8.9.3/8.9.3 (Luck Envoy)) with ESMTP id QAA18410
	for <kdincer@tubitak.gov.tr>; Mon, 3 Apr 2000 16:35:06 +0400 (EET DST)
Received: from kemane.ceng.metu.edu.tr (e109762@kemane [144.122.171.120])
	by mendelson.ceng.metu.edu.tr (8.9.0/8.9.0) with ESMTP id QAA25831
	for <kdincer@tubitak.gov.tr>; Mon, 3 Apr 2000 16:46:16 +0300 (EET DST)
Received: (from e109762@localhost)
	by kemane.ceng.metu.edu.tr (8.9.3/8.9.3) id QAA04184
	for kdincer@tubitak.gov.tr; Mon, 3 Apr 2000 16:44:47 +0300 (EET DST)
Date: Mon, 3 Apr 2000 16:44:47 +0300 (EET DST)
From: KURT NURI GOKHAN <e109762@ceng.metu.edu.tr>
Message-Id: <200004031344.QAA04184@kemane.ceng.metu.edu.tr>
To: kdincer@tubitak.gov.tr

#include <stdlib.h>
#include <math.h>
#include <stdio.h>
#include <string.h>
#include <string>
#include <iostream>
#include <fstream>
#define MAX_LABELS 1024
#define MAX_LINES 1024
#define INVALID_ADRESS -1
#define INVALID_CODE -1
#define YES_BYTE 1
#define NO_BYTE 0

string prog_name;
int start_adress;

class OPTAB 
 {
      struct inst { string name; 
                    int code;
       	       	  };
      inst optab[27];

   public:
      int get_code( string );
      OPTAB(void); 
 } OPTAB ;

class SYMTAB 
 {   
     int cur_no_labels; //holds the current number of inserted labels
     struct label { string name;
		    int adress;
		  };
    
   public:
     label symtab[MAX_LABELS]; 
     void put_label( string,int );
     int  get_label( string label );
     void control_labels(void);
     SYMTAB(void) {cur_no_labels=0;};
     int get_cur_no_labels(void){return cur_no_labels;};
     
 } SYMTAB ;

class LOCCTR
 {
     int line_locctr;
     int mem_locctr;
   
   public:
     void set_mem_locctr(int n) {mem_locctr=n;};
     void inc_mem_locctr(void) { mem_locctr +=3;};
     void inc_mem_locctr(int n) { mem_locctr +=n;};
     void inc_line_locctr(void) { line_locctr ++;};
     int get_mem_locctr(void) {return mem_locctr;};
     int get_line_locctr(void) {return line_locctr;};
     LOCCTR(void) { line_locctr=0; mem_locctr=0;};
  
  } LOCCTR ;

class LINE_READER
 {
     int format_of_line;   //this is a number 1 to 9 defining the format
                           //of the line read. look below for various formats
     string real_label;    //label appearing in front of a line 
     string operand_label; //label appearing at operand field
     string instruction;   //name of instruction appering at the current line
     int constant;         //constant part of format if instruction is one of the
                           //WORD RESW RESB
     string byte_constant; //constant appearing when instruction is BYTE
     int indirect;         //if indirect =1 else =0*/
                           // when there is " , X " appears in the line

  public :                 //   no         format 
                           //  ----       --------
     void read_line(std::ifstream &); //   1           instr                (only when instr=RSUB)
                           //   2           instr label
                           //   3     label instr label
            		   //   4           instr , X label      (indirect=1)
                           //   5     label instr , X label      (indirect=1)
 			   //   6     label instr constant       (instr=WORD , RESW or RESB)
			   //   7     label instr byte_constant  (instr=BYTE)
                           //   8           instr label          (instr=END)
     int get_format_of_line(void) {return format_of_line;};
     string get_real_label(void) {return real_label;};
     string get_operand_label(void) {return operand_label;};
     string get_instruction(void) {return instruction;};
     int get_constant(void) {return constant;};
     string get_byte_contant(void) {return byte_constant;};
     int get_indirect(void) { return indirect;};


  // file named "input.txt is opened for reading std::ifstream from("input.txt");
  // string s;  define a string
  // from >> s; get a string without white characters into the string s from the file from

  //int i=0x10; define an integer with hexadecimal value 0x10 
  //cout << hex << i; output as hexadecimal

 } LINE_READER;


class CODE_TABLE
 {
   struct entry { char opcode[3]; 
                  char operand[5];
                  int adress;
                  int byte; //if byte==1(YES_BYTE) opcode holds 
                            //the 1 byte length  operand of BYTE
                };

   entry allcode[MAX_LINES]; 
   int cur_no_code;

  public :
   CODE_TABLE(void) { cur_no_code=0;start_adress=0;};
   void insert(int,int,int);
   void insert(int,int);
   void insertb(int,int);
   void printall(void);
   void print_formal(const char *);

} CODE_TABLE ;

  

char itoh(int i)
 {
  if (i<0 || i>16)
   {cout << "undetermined constant\n"; return 48; }
  else if(i<10 && i>=0)
   return i+48;
  else if(i>=10 && i<=16)
   return i+55;
 }

int htoi(char c)
 {
  if(c>=48 && c<=57)
   return c-48;
  else if(c>=65 && c<=70)
   return c-55;
  else {cout << "undetermined constant\n";}
 }

 //replaces an integer number to asci represantation of its hex value
void IntHexAsci2(int in , char * c)
 {
  c[0]=itoh(in/16);
  c[1]=itoh(in%16);
  c[2]='\0';
 }
void IntHexAsci4(int in , char * c) 
 {
  c[0]=itoh(in/(16*16*16));
  c[1]=itoh((in/(16*16))%16);
  c[2]=itoh((((in/16)%(16))%16));
  c[3]=itoh(in%16);
  c[4]='\0';
 }
void IntHexAsci6(int in , char * c1 , char * c2) 
 {
  c1[0]=itoh(in/(16*16*16*16*16));
  c1[1]=itoh((in/(16*16*16*16))%16);
  c2[0]=itoh((((in/(16*16*16))%(16))%16));
  c2[1]=itoh(((((in/(16*16))%(16))%(16))%(16)));
  c2[2]=itoh((((((in/16)%(16))%(16))%(16))%(16)));
  c2[3]=itoh(in%16);
  c1[2]='\0';
  c2[4]='\0';
 }

void CODE_TABLE::insert(int opcode , int operand , int adress)
 {
  int i;
 
  IntHexAsci2(opcode,allcode[cur_no_code].opcode);
  IntHexAsci4(operand,allcode[cur_no_code].operand);
  allcode[cur_no_code].adress=adress;
  allcode[cur_no_code].byte=NO_BYTE;
  cur_no_code++;
 }

void CODE_TABLE::insert(int constant , int adress)
 {
  IntHexAsci6(constant,allcode[cur_no_code].opcode,allcode[cur_no_code].operand);
  allcode[cur_no_code].adress=adress;
  allcode[cur_no_code].byte=NO_BYTE;
  cur_no_code++;
 }
  
void CODE_TABLE::insertb(int constant , int adress)
 {
  IntHexAsci2(constant,allcode[cur_no_code].opcode);
  allcode[cur_no_code].adress=adress;
  allcode[cur_no_code].byte=YES_BYTE;
  cur_no_code++;
 }

void CODE_TABLE::printall(void)
 {
  int i;
  
  for(i=0;i<cur_no_code;i++)
   {
    if(allcode[i].byte==NO_BYTE)
     {
      cout << hex << allcode[i].adress << " : " << allcode[i].opcode << allcode[i].operand << '\n';
     }
    else 
     {
      cout << hex << allcode[i].adress << " : "  <<  allcode[i].opcode << '\n';
     }
   }
  }

void CODE_TABLE::print_formal(const char * f)
 {
  std::ofstream fp(f);
  string s1;
  int i=0;
  if(prog_name.length()>6) {cout << "long prog name\n"; return;}

  fp << "H";
  fp << prog_name;
  for(i=prog_name.length();i<6;i++)
   fp << ' ' ;
      char c1[3],c2[5];
      IntHexAsci6(start_adress,c1,c2);
     fp <<  c1 << c2 << '\n';

  int rec_len=0;
  int all_length=0;
  int adress=0;
  i=0;
 
  adress=allcode[i].adress;
  
  for(i=0 ; i<cur_no_code ;)
   {
    if(allcode[i].byte==YES_BYTE)
     {
      s1+=allcode[i].opcode;
      rec_len++;
     }
    else 
     {
      s1+=allcode[i].opcode;
      s1+=allcode[i].operand;
      rec_len+=3;
     }
   
    if(i+1!=cur_no_code && rec_len!=0xFF &&
         (allcode[i+1].adress-1==allcode[i].adress || 
            allcode[i+1].adress-3==allcode[i].adress))
     { i++; continue; }
   else 
    {
     fp << 'T';
      char c1[3],c2[5];
      IntHexAsci6(adress,c1,c2);
     fp <<   c1 << c2 ;
      IntHexAsci2(rec_len,c1);
     fp <<  c1  ;
     fp << s1;
     fp << '\n';
     if(i+1==cur_no_code) 
      {
       char c1[3],c2[5];
       IntHexAsci6(start_adress,c1,c2);
       fp << 'E'; fp << c1 << c2; return;
      }
     else 
     {
      rec_len=0; s1=""; adress=allcode[++i].adress; continue; 
     }
    }
  }
 }
    
/*********************************************************************/

OPTAB::OPTAB(void) 
 { 
   optab[0].name="ADD";    optab[13].name="MUL";
   optab[0].code=0x18;     optab[13].code=0x20;
   optab[1].name="AND";    optab[14].name="OR";
   optab[1].code=0x40;     optab[14].code=0x44;
   optab[2].name="COMP";   optab[15].name="RD";
   optab[2].code=0x28;     optab[15].code=0xD8;
   optab[3].name="DIV";    optab[16].name="RSUB";
   optab[3].code=0x24;     optab[16].code=0x4C;
   optab[4].name="J";      optab[17].name="STA";
   optab[4].code=0x3C;     optab[17].code=0x0C;
   optab[5].name="JEQ";    optab[18].name="STCH";
   optab[5].code=0x30;     optab[18].code=0x54;
   optab[6].name="JGT";    optab[19].name="STL";
   optab[6].code=0x34;     optab[19].code=0x14;
   optab[7].name="JLT";    optab[20].name="STSW";
   optab[7].code=0x38;     optab[20].code=0xE8;
   optab[8].name="JSUB";   optab[21].name="STX";
   optab[8].code=0x48;     optab[21].code=0x10;
   optab[9].name="LDA";    optab[22].name="SUB";
   optab[9].code=0x00;     optab[22].code=0x1C;
   optab[10].name="LDCH";  optab[23].name="TD";
   optab[10].code=0x50;    optab[23].code=0xE0;
   optab[11].name="LDL";   optab[24].name="TIX";
   optab[11].code=0x08;    optab[24].code=0x2C;
   optab[12].name="LDX";   optab[25].name="WD";
   optab[12].code=0x04;    optab[25].code=0xDC;
 }
			  
int OPTAB::get_code( string instruction )
 {
  int i;
  for(i=0 ; i<26 ; i++)
   {
    if(instruction==optab[i].name) return optab[i].code;
   }
  return INVALID_CODE;
   // cout << "no such machine instruction exists :" << instruction;
 } 

/********************************************************************/

void SYMTAB::put_label( string label,int adress )
 {
  int i;
  int exists=0;
  if(adress<INVALID_ADRESS) { cout << "invalid adress less than -1\n"; return;}
  if(cur_no_labels==MAX_LABELS) { cout << "lots of labels\n"; return;}
  if(adress==INVALID_ADRESS)
   { 
     for(i=0 ; i<cur_no_labels ; i++)
      {
       if(symtab[i].name==label) {exists=1; break;}
      }
     if(!exists) { symtab[i].name=label; 
                   symtab[i].adress=adress;
                   cur_no_labels++; 
       		 } 
   }
  else
   { 
     exists=0;
     for(i=0 ; i<cur_no_labels ; i++)
      {
       if(symtab[i].name==label)
          if(symtab[i].adress!=INVALID_ADRESS) 
           { cout<<"twin labels : "<<label<<'\n'; break; }
          else { symtab[i].adress=adress; exists=1; break;}
      }
     if(!exists) { symtab[i].name=label; 
                   symtab[i].adress=adress;
                   cur_no_labels++; 
		 } 
    }
 }

int SYMTAB::get_label( string label )
 {
  int i;
  for(i=0 ; i<cur_no_labels ; i++)
   if(symtab[i].name==label) return symtab[i].adress;
  cout << "no such label exists : "  << label<< '\n';
 }
 
void SYMTAB::control_labels(void)
 {
  int i;
  for(i=0 ; i<cur_no_labels ; i++)
   {
    if(symtab[i].adress==INVALID_ADRESS)
     {
      cout << "invalid adress for label : " << symtab[i].name << '\n'; return;
     }
   }
 }

/**************************************************************************/



void LINE_READER::read_line(std::ifstream & fp)
 {
  int i;
  string s1,s2,s3,s4;

  fp >> s1;
  
  i=OPTAB.get_code(s1);

  if(s1=="END") { fp >> s2 ;operand_label =s2; format_of_line=8;  return; }

  if(i==INVALID_CODE)
   {
    fp >> s2;
    i=OPTAB.get_code(s2);
    if(i==INVALID_CODE) 
     {
      if(s2=="WORD")
       {
        fp >> dec >> i;
        real_label=s1; instruction=s2; constant=i; format_of_line=6; return;
       }
      else if(s2=="RESW" || s2=="RESB" )
       {
        fp >> dec >>   i;
        real_label=s1; instruction=s2; constant=i; format_of_line=6; return;
       }
      else if(s2=="BYTE")
      {
        fp >> s3;
        real_label=s1; instruction=s2; byte_constant=s3; format_of_line=7; return;
      }
      else if (s2=="START")
      {
       fp >> hex >>  i;
       LOCCTR.set_mem_locctr(i);
       constant=i;
       real_label=s1;
       format_of_line=0;
       return;
      }
      else
      {
        cout<< "unresolved code "<<s1<<" or "<<s2 << '\n'; return;
      }
     }
    else
     {
      instruction=s2; real_label=s1;

      fp >> s3;
      if(s3!=",")
       {
        operand_label=s3; format_of_line=3; return;
       }
     else 
       {
        fp >> s4;
        if(s4!="X") {cout << "wrong register number " << s4 <<'\n' ;return;}
        fp >> s4;
        operand_label=s4; format_of_line=5; return;
       }
     }
   }
   else
    {
     if (s1=="RSUB")
      {
       instruction=s1; format_of_line=1; return;
      }
     else
      {
       fp >> s2;
       if(s2==",")
        {
         fp >> s2;
         if(s2=="X")
          {
           fp >> s2;
           instruction=s1; operand_label=s2; format_of_line=4; return;
          }
          else
          {
           cout << "wrong reg "<< s2<<'\n';
          }
        }
       else
        {
         instruction=s1; operand_label=s2; format_of_line=2; return;
        }
      }
    }
 }
         
/******************************************************************************/

void Pass1(const char * f)
 {
  int i,f_of_line,constant,indirect;
  string real_label,operand_label,instruction,byte_constant;
  std::ifstream fp(f);
  
  while (1)
   {  
  if(fp.eof()) { cout << "wrong ending"<< '\n'; return;}
    LINE_READER.read_line(fp);
    f_of_line=LINE_READER.get_format_of_line();
    real_label=LINE_READER.get_real_label(); 
    operand_label=LINE_READER.get_operand_label();
    instruction=LINE_READER.get_instruction();
    constant=LINE_READER.get_constant();
    byte_constant=LINE_READER.get_byte_contant();
    indirect=LINE_READER.get_indirect(); 


    if(f_of_line==0) continue;

    else if(f_of_line==1)
     {
      LOCCTR.inc_mem_locctr();
      continue;
     }
    else if(f_of_line==2 || f_of_line==4)
    {
     SYMTAB.put_label(operand_label,INVALID_ADRESS);
     LOCCTR.inc_mem_locctr();
     continue;
    }     
   else if(f_of_line==3 || f_of_line==5)
    {
     SYMTAB.put_label(operand_label,INVALID_ADRESS);
     SYMTAB.put_label(real_label,LOCCTR.get_mem_locctr());
     LOCCTR.inc_mem_locctr();
     continue;
    } 
   else if(f_of_line==6)
    {
     SYMTAB.put_label(real_label,LOCCTR.get_mem_locctr());
     if(instruction=="WORD")
      {
        LOCCTR.inc_mem_locctr();
      }
     else if(instruction=="RESW")
      {
        LOCCTR.inc_mem_locctr(3*constant);
      }
     else if(instruction=="RESB")
      {
        LOCCTR.inc_mem_locctr(constant);
      }
     continue;
    }
   else if(f_of_line==7) 
    {
     SYMTAB.put_label(real_label,LOCCTR.get_mem_locctr());
     i=byte_constant.length();
     const char * pl=byte_constant.data();
    
     if(pl[0]=='C')
      {
       LOCCTR.inc_mem_locctr(i-3);
      }
     else if(pl[0]=='X')
      {
       LOCCTR.inc_mem_locctr((i-3)/2);
      }
     else
     { cout << "not a X or C \n"; return;
     }
     continue;
    }
  else if(f_of_line==8)
   {
    SYMTAB.put_label(operand_label,INVALID_ADRESS);
    return;      
   }


  }

 fp.close();
 }


/******************************************************************************/

void Pass2(const char * f)
 {
  int i,f_of_line,constant,indirect,instr_code,adr_opr_lab;
  string real_label,operand_label,instruction,byte_constant;

  std::ifstream fp("input.txt");
  
 
  while (1)
   {
  if(fp.eof()) { cout << "wrong ending\n"; return;}

    LINE_READER.read_line(fp);
    f_of_line=LINE_READER.get_format_of_line();
    real_label=LINE_READER.get_real_label();
    operand_label=LINE_READER.get_operand_label();
    instruction=LINE_READER.get_instruction();
    constant=LINE_READER.get_constant();
    byte_constant=LINE_READER.get_byte_contant();
    indirect=LINE_READER.get_indirect();  
    instr_code=OPTAB.get_code(instruction);
    adr_opr_lab=SYMTAB.get_label(operand_label);

    if(f_of_line==0){ prog_name=real_label; start_adress=constant; continue;}

    else if(f_of_line==2 || f_of_line==3)
     {
      CODE_TABLE.insert(instr_code,adr_opr_lab,LOCCTR.get_mem_locctr());
      LOCCTR.inc_mem_locctr();
      continue;
     }
    else if(f_of_line==4 || f_of_line==5)
     {
      CODE_TABLE.insert(instr_code,adr_opr_lab+pow(2,15),LOCCTR.get_mem_locctr());
      LOCCTR.inc_mem_locctr();
      continue;
     }
    else if(f_of_line==1)
     {
      CODE_TABLE.insert(instr_code,0,LOCCTR.get_mem_locctr());
      LOCCTR.inc_mem_locctr();
      continue;
     }
    else if(f_of_line==6 || f_of_line==7)
     {
      if(instruction=="WORD")
       {
        CODE_TABLE.insert(constant,LOCCTR.get_mem_locctr());
        LOCCTR.inc_mem_locctr();
        continue;
       }
      else if(instruction=="RESB")
       {
        LOCCTR.inc_mem_locctr(constant);
        continue;
       }
      else if(instruction=="RESW")
       {
        LOCCTR.inc_mem_locctr(3*constant);
        continue;
       }
      else if(instruction=="BYTE")
       {
        const char * pl=byte_constant.data();
        int k=0;
        
        if(pl[0]=='C')
          {
           for(i=2;i<byte_constant.length()-1;i++)
            {
             CODE_TABLE.insertb(pl[i],LOCCTR.get_mem_locctr());
             LOCCTR.inc_mem_locctr(1);
            }
           continue;
          } 
        else if(pl[0]=='X')
         {
          for(i=2;i<byte_constant.length()-1;i++)
           {
            if(pl[i+1]=='\'')
             {
              CODE_TABLE.insertb(htoi(pl[i]),LOCCTR.get_mem_locctr());
             }
            else 
             {
              CODE_TABLE.insertb(htoi(pl[i])*16+htoi(pl[i+1]),LOCCTR.get_mem_locctr());
              i++;
             }
             LOCCTR.inc_mem_locctr(1);
           }
          continue;    
        }        
     }
   }
 else if(f_of_line==8)
  return;
  }
fp.close();
}

/******************************************************************************/

int main( int argc , char * argv[])
{
int i;

if(argc<3) {cout << "wrong no of args\n"; return 0;}

Pass1(argv[1]);

if (argc==4 && !strcmp( argv[3],"symtab"))
{
cout << "SYMTAB\n";
for(i=0;i<SYMTAB.get_cur_no_labels();i++)
  {
    cout << SYMTAB.symtab[i].name<< "  " ;
    cout << hex <<  SYMTAB.symtab[i].adress ;
    cout << '\n';
  }
}
SYMTAB.control_labels();
Pass2(argv[1]);

if(argc==4 && !strcmp( argv[3],"listing"))
{
cout << "LISTING\n";
CODE_TABLE.printall();
}


CODE_TABLE.print_formal(argv[2]);

}













