// Ozan Okan Avci 
// 1097088 
 
#include <stdio.h> 
#include <stdlib.h> 
#include <string.h> 
FILE *fpin,*fpout; 
char opers[][5]={"ADD","AND","COMP","DIV","J","JEQ","JGT", "JLT","JSUB","LDA",
LDCH","LDL","LDX","MUL", "OR","RD","RSUB","STA","STCH","STL","STX","SUB","TD","
IX","WD"}; 
char codes[][3]={"18","40","28","24","3C","30","34","38","48","00","50","08","
4","20","44","D8","4C","0C","54","14","10","1C","E0","2C","DC"}; 
 
 
//*************************************************************************** 
class Source_Line 
{ public:  Source_Line() {  
			  label=(char *)malloc(sizeof(char)*9); 
			  oper=(char *)malloc(sizeof(char)*7); 
			  operand=(char *)malloc(sizeof(char)*19); 
			  comment=(char *)malloc(sizeof(char)*32); 
			  strcpy(label,""); 
			  strcpy(oper,""); 
			  strcpy(operand,""); 
			  strcpy(comment,""); 
                         } 
 	   char line[67]; 
           parser(char *c); 
           parser2(char *lin,int *locctr); 
           char *label; 
	   char *oper; 
           char *operand; 
           char *comment; 
           int commnt; 
}; 
//*************************************************************************** 
class Optab 
{ public: 
            
	   char *search(char *chk); 
}; 
//*************************************************************************** 
class Symtab 
{ public: 
  	struct sss { char symbol[9]; 
                    int locctr; 
        	    struct sss *next; 
                   }; 
           struct sss *head; 
           struct sss *prenode; 
           struct sss *node; 
           void insert(char *yeni,int locctr); 
           int search(char *old); 
           SymTab(){head=NULL;} 
};  
//*************************************************************************** 
 
class Source_Code  
{ public :  Source_Code() {;} 
	    int LOCCTR; 
            int ProgLength; 
            class Source_Line current; 
            pass1(); 
            pass2(); 
            char progname[7]; 
            int start_addr; 
            class Symtab symb_table; 
            class Optab op_table; 
            commentmi(char *lin); 
            writeheader(FILE *fpout); 
            write_text_record(FILE *fpout,char *record,int record_starting_add
,int recordlength); 
            write_end_record(FILE *fpout,int addr); 
            dec2hex(char *hex,int dec); 
            hex2dec(char *hex); 
            assemblecode(char *komut,char *opcode,int operandaddr); 
            convertconstant(char *convertedcode,char *opcode,char *operand); 
            terslashn_temizle(char *lin); 
            search_and_set(); 
}; 
//************************************************************************** 
Source_Line::parser(char *c) 
{ 
 strncpy(this->label,c,8); 
 c=c+9;      // label ve boslugu atla 
 strncpy(this->oper,c,6); 
 c=c+8;     // operation ve boslugu atla 
 strncpy(this->operand,c,18); 
 c=c+18;   // operandi atla 
 strncpy(this->comment,c,31); 
} 
//************************************************************************** 
Source_Code::commentmi(char *lin) 
{ 
 int i=0,k=0; 
 while(lin[i] != 0) 
 { 
 if(lin[i++] == '.') 
 return 1; 
 } 
 return 0; 
} 
//************************************************************************** 
Source_Code::search_and_set() 
{ 
  int i=0; 
  char temp[33]; 
  char symbol[9]=""; 
  strcpy(temp,this->current.operand); 
  while(temp[i] != 0 && temp[i] != ',' && i < 8) 
  { 
   symbol[i]=temp[i]; 
   i++; 
  } 
  symbol[8]=0; 
  if(temp[i] == 0 || i >= 8) 
  return 0; 
  else  
  { 
   if(this->symb_table.search(symbol)) 
    return this->symb_table.search(symbol)+4096*8; 
  } 
  return 0; 
} 
//****************************************************************************
*** 
Source_Code::pass1() 
{ char lin[67]; 
 char lin2[75]; 
  int i; 
  int k=0; 
  int LOCCTRESKI; 
  symb_table.head=NULL; 
 
  while (fgets(lin,67,fpin)!=NULL) 
  {  
    current.parser(lin); 
 
  if(k++ == 0) 
   { 
    if (!strncmp(current.oper,"START",5)) 
    { strcpy(progname,current.label); 
      start_addr=hex2dec(current.operand); 
      LOCCTR=start_addr; 
      fprintf(fpout,"%d %s",LOCCTR,lin); 
      continue; 
    } 
     else { LOCCTR=0; } 
   } 
     
     if(!strncmp(current.oper,"END",3)) 
     { 
      strcpy(lin2,"     "); 
      strcat(lin2,lin); 
      fprintf(fpout,"%s",lin2); 
      break; 
     } 
       
      if (!this->commentmi(lin)) 
      { char *found; 
        if (current.label!=NULL) 
        { int found; 
          if ((found=symb_table.search(current.label))) 
           /* give_error_message */ ; 
           else  
            symb_table.insert(current.label,LOCCTR); 
        }  
         
        found=op_table.search(current.oper); 
        LOCCTRESKI=LOCCTR; 
        if (found)  
         LOCCTR+=3;   // problem olabilir 
        else if( !strcmp(current.oper,"WORD")) 
             LOCCTR +=3; 
        else if( !strcmp(current.oper,"RESW")) 
             LOCCTR += 3*atoi(current.operand); 
        else if( !strcmp(current.oper,"RESB")) 
             LOCCTR += atoi(current.operand); 
        else if( !strcmp(current.oper,"BYTE")) 
            { 
             int len=0; 
             int i=2; 
             if(current.operand[0]== 'C') 
             { 
               while(current.operand[i++] != '\'') 
               len++; 
             LOCCTR +=len; 
             } 
             if(current.operand[0]== 'X') 
             { 
               while(current.operand[i++] != '\'') 
               len++; 
             LOCCTR +=len/2; 
             } 
            } 
	else  ; // give error message 
      }     
      if (this->commentmi(lin))  
       { 
        fprintf(fpout,"     %s",lin); 
        continue; 
       } 
       
    fprintf(fpout,"%d %s",LOCCTRESKI,lin); 
    } 
    ProgLength=LOCCTR-start_addr; 
    fclose(fpout); 
} 
//*************************************************************************** 
int Symtab::search(char *aranan) 
{ 
 struct sss *temp; 
 int len; 
 temp=head; 
 len =0; 
 while(aranan[len] != 0 && aranan[len] != ' ' && aranan[len] != '\n') 
 len++; 
 aranan[len]=0; 
  
 while(temp != NULL) 
{ 
  if(!strncmp(temp->symbol,aranan,len)) 
   { 
    return temp->locctr; 
   } 
  else temp=temp->next; 
} 
return 0; 
} 
//*************************************************************************** 
char *Optab::search(char *chk) 
{ 
 int i=0; 
 int len=0; 
 int k=0; 
 while(chk[k] != 0 && *(chk+k) != ' ' && *(chk+k) != '\n') 
 { 
  len++; 
  k++; 
 } 
 chk[len]=0; 
 while( i < 25) 
 { 
  if(!strcmp(opers[i],chk)) 
   { 
    return codes[i]; 
   } 
  i++; 
 } 
 return NULL; 
} 
//*************************************************************************** 
void  Symtab::insert(char *yeni,int locctr) 
{ 
 if(this->head == NULL) 
  { 
   node=(struct sss *) malloc(sizeof(struct sss)); 
   int i=0; 
   while(yeni[i] != 0 && yeni[i] != ' ' && yeni[i] != '\n') 
   i++; 
   yeni[i]=0; 
   strcpy(this->node->symbol,yeni); 
   this->node->locctr=locctr; 
   this->node->next=NULL; 
   this->head = node; 
  } 
 
 else 
  { 
   prenode=this->head; 
   while(prenode != NULL) 
   { 
     node=prenode; 
     prenode=prenode->next; 
   } 
   prenode=node; 
   node=(struct sss *) malloc(sizeof(struct sss)); 
   int i=0; 
   while(yeni[i] != 0 && yeni[i] != ' ' && yeni[i] != '\n') 
   i++; 
   yeni[i]=0; 
   strcpy(node->symbol,yeni); 
   prenode->next=node; 
   this->node->locctr=locctr; 
   node->next=NULL; 
  } 
} 
//*************************************************************************** 
int main(int argc,char **argv) 
{ 
 char hex[5]=""; 
 fpin=fopen("source.asm","r"); 
 fpout=fopen("inter.asm","w"); 
 class Source_Code source_code; 
 source_code.pass1(); 
 source_code.pass2(); 
 source_code.dec2hex(hex,1000); 
 return 0; 
} 
//*************************************************************************** 
Source_Line::parser2(char *c,int *locctr) 
{ 
 char temp[5]=""; 
 strncpy(temp,c,4); 
 *locctr=atoi(temp); 
 c=c+5; 
 strncpy(this->label,c,8); 
 c=c+9;      // label ve boslugu atla 
 strncpy(this->oper,c,6); 
 c=c+8;     // operation ve boslugu atla 
 strncpy(this->operand,c,18); 
 c=c+18;   // operandi atla 
 strncpy(this->comment,c,31); 
} 
//*************************************************************************** 
Source_Code::dec2hex(char *hex,int dec) 
{ 
 int k3,k2,k1,k0; 
 strcpy(hex,""); 
 k3=dec%16; 
 if(k3 >= 10) 
 hex[3] = 'A' - 10+k3; 
 else 
 hex[3] = k3+'0'; 
 dec /=16; 
 k2=dec%16; 
 if(k2 >= 10) 
 hex[2] = 'A' - 10+k2; 
 else 
 hex[2] = k2+'0'; 
 dec /=16; 
 k1=dec%16; 
 if(k1 >= 10) 
 hex[1] = 'A' - 10+k1; 
 else 
 hex[1] = k1+'0'; 
 dec /=16; 
 k0 = dec; 
 if(k0 >= 10) 
 hex[0] = 'A' - 10+k0; 
 else 
 hex[0] = k0+'0'; 
 return 0; 
} 
//*************************************************************************** 
Source_Code::writeheader(FILE *fpout) 
{ 
 char hex[5]=""; 
 char hex2[5]=""; 
 char temp[7]="00"; 
 int len; 
 fprintf(fpout,"H"); 
 progname[7]=0; 
 fprintf(fpout,"%s",progname); 
 dec2hex(hex2,start_addr); 
 strcat(temp,hex2); 
 fprintf(fpout,"%s",temp); 
 dec2hex(hex,ProgLength); 
 len=strlen(hex); 
 len = 6 - len; 
 while(len--) 
 { 
  fprintf(fpout," "); 
 } 
 fprintf(fpout,"%s\n",hex); 
} 
//*********************************************************************  
Source_Code::write_text_record(FILE *fpout,char *record,int record_starting_ad
r,int recordlength) 
{ 
 char hex[5]=""; 
 char deger[3]=""; 
 fprintf(fpout,"T"); 
 dec2hex(hex,record_starting_addr); 
 fprintf(fpout,"00%s",hex); 
 memset(hex,0,5); 
 dec2hex(hex,recordlength); 
 deger[0]=hex[3]; 
 deger[1]=hex[4]; 
 fprintf(fpout,"%s",deger); 
 fprintf(fpout,"%s\n",record); 
} 
//*********************************************************************  
Source_Code::write_end_record(FILE *fpout,int addr) 
{ 
 char hex[5]=""; 
 dec2hex(hex,addr); 
 fprintf(fpout,"E00%s\n",hex); 
} 
//*********************************************************************  
Source_Code::hex2dec(char *hex) 
{ 
 int number =0; 
 if(hex[0] <= '9') 
  number += hex[0]-'0'; 
 else 
  number +=hex[0]-'A'+10; 
 number *=16; 
 if(hex[1] <= '9') 
  number += hex[1]-'0'; 
 else 
  number +=hex[1]-'A'+10; 
 number *=16; 
 if(hex[2] <= '9') 
  number += hex[2]-'0'; 
 else 
  number +=hex[2]-'A'+10; 
 number *=16; 
 if(hex[3] <= '9') 
  number += hex[3]-'0'; 
 else 
  number +=hex[3]-'A'+10; 
 return number; 
} 
//*********************************************************************  
  
Source_Code::assemblecode(char *komut,char *opcode , int operandaddr) 
{ 
 char hex[5]=""; 
 dec2hex(hex,operandaddr); 
 strcpy(komut,opcode); 
 strcat(komut,hex); 
 return 0; 
} 
//*********************************************************************  
Source_Code::convertconstant(char *convertedcode,char *oper,char *operand) 
{ 
 if(!strncmp(oper,"WORD",4)) 
  { 
    char hex[5]=""; 
    char temp[7]=""; 
    int len=0; 
    dec2hex(hex,atoi(operand)); 
    len=strlen(hex); 
    len =6-len; 
    while(len -- > 0) 
    { 
     strcat(temp,"0"); 
    } 
    strcat(temp,hex); 
    strcpy(convertedcode,temp); 
   } 
 else 
  { 
   if(operand[0] == 'X') 
   { 
    char temp[2]=""; 
    temp[0]=operand[2]; 
    temp[1]=0; 
    strcpy(convertedcode,temp); 
    temp[0]=operand[3]; 
    strcat(convertedcode,temp); 
    return strlen(convertedcode); 
   } 
   else 
   { 
     int deg; 
     int i=2; 
     char deger[3]=""; 
     while(operand[i] != '\'') 
      { 
       char hex[5]=""; 
       deg=operand[i]; 
       dec2hex(hex,deg); 
       deger[0]=hex[2]; 
       deger[1]=hex[3]; 
       strcat(convertedcode,deger); 
       i++; 
      } 
       return strlen(convertedcode); 
   } 
  } 
} 
//*********************************************************************  
Source_Code::terslashn_temizle(char *lin) 
{ 
 int i=0; 
 while(lin[i] != 0 && lin[i] != '\n') 
 i++; 
 lin[i]=0; 
}  
//*********************************************************************  
Source_Code::pass2() 
{ 
 char lin[72]; 
 int locctr; 
 int operandaddr; 
 int record_starting_addr; 
 int convdonen; 
 char opcode[3]=""; 
 char komut[7]="";  
 char record[61]=""; 
 int recordlength=0; 
 FILE *fpin,*fpout; 
 fpin=fopen("inter.asm","r"); 
 fpout=fopen("objectfile","w"); 
 fgets(lin,72,fpin); 
 this->terslashn_temizle(lin); 
 this->current.parser2(lin,&locctr); 
 if(!strncmp(current.oper,"START",5)) 
   { 
    memset(lin,0,72); 
    fgets(lin,72,fpin); 
    terslashn_temizle(lin); 
    this->current.parser2(lin,&locctr); 
   } 
 this->writeheader(fpout); 
 recordlength=0; 
 record_starting_addr=locctr; 
 while(strncmp(current.oper,"END",3)) 
  { 
    if(!commentmi(lin)) 
     { 
      if(op_table.search(current.oper)) 
       { 
        strcpy(opcode,op_table.search(current.oper)); 
        if(strcmp(current.operand,"")) 
        { 
          if(symb_table.search(current.operand)) 
           { 
             operandaddr=symb_table.search(current.operand); 
           } 
          else 
           { 
            operandaddr=search_and_set(); 
             
	    // set error flag 
           } 
        } 
        else 
         { 
           operandaddr=0; 
         } 
          assemblecode(komut,opcode,operandaddr); 
     } // end if found 
     else if(!strncmp(current.oper,"BYTE",4)|| !strncmp(current.oper,"WORD",4)
 
      { 
         convdonen=convertconstant(komut,current.oper,current.operand);   
      } 
     if(recordlength + strlen(komut) > 60) 
       { 
         write_text_record(fpout,record,record_starting_addr,recordlength); 
	memset(record,0,61); 
        recordlength=0; 
        record_starting_addr=locctr; 
       } 
     if(strncmp(current.oper,"RESW",4) && (strncmp(current.oper,"RESB",4))) 
       { 
        if(strncmp("BYTE",current.oper,4)) 
         {strcat(record,komut); 
          recordlength +=6;} 
        else 
        { 
         recordlength +=convdonen; 
         strcat(record,komut); 
        } 
       } 
     } 
  memset(lin,0,72); 
  fgets(lin,72,fpin); 
  terslashn_temizle(lin); 
  this->current.parser2(lin,&locctr); 
  } 
   write_text_record(fpout,record,record_starting_addr,recordlength); 
   write_end_record(fpout,start_addr); 
} 
//*********************************************************************  
